=== debian/changelog ===
calceph (4.0.5-2) experimental; urgency=medium

  * Added autopkgtest integration tests

 -- Attila Kovacs <attipaci@gmail.com>  Tue, 22 Jul 2025 14:36:04 +0200

calceph (4.0.5-1) experimental; urgency=medium

  * Update to upstream 4.0.5 
  * Update debian/libcalceph2.symbols

 -- Attila Kovacs <attipaci@gmail.com>  Wed, 04 Jun 2025 14:43:06 +0200
