=== debian/control ===
Source: calceph
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Attila Kovacs <attila.kovacs@cfa.harvard.edu>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13), cmake, gfortran
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/calceph
Vcs-Git: https://salsa.debian.org/debian-astro-team/calceph.git
Homepage: https://www.imcce.fr/inpop/calceph
Rules-Requires-Root: no
Testsuite: autopkgtest

Package: calceph
Architecture: any
Section: science
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Planetary ephemeris data access tools
 This package provides the command-line tools provided by the CALCEPH library.
 The CALCEPH Library is designed to access planetary ephemeris data, such
 INPOPxx and JPL DExxx ephemeris files, and the SPICE kernel (SPK) files.

Package: libcalceph2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Shared library for planetary ephemeris data access
 The CALCEPH Library is designed to access the binary planetary ephemeris
 files, such INPOPxx and JPL DExxx ephemeris files, and the SPICE kernel
 (SPK) files.

Package: libcalceph-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libcalceph2 (= ${binary:Version})
Description: C development files for planetary ephemeris data access
 This sub-package provides C headers and non-versioned shared library symbolic
 links for the CALCEPH library.

Package: libcalceph-fortran-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libcalceph2 (= ${binary:Version})
Description: Fortran bindings for the CALCEPH library
 This sub-package provides bindings for Fotran development that wants to use
 CALCEPH.
