=== debian/tests/control ===
Tests: test-functionality
Depends: @, build-essential, shunit2
Restrictions: allow-stderr
